//+------------------------------------------------------------------+
//|                                            Offs Entry Signal.mq4 |
//|                               Copyright  2013, Antonio Jimnez. |
//|                                  E-mail: tony20_1987@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Antonio Jimnez Barrios"

#property indicator_chart_window
#property indicator_buffers   3

#property indicator_color1    Lime
#property indicator_color2    Red
#property indicator_color3    Yellow

#property indicator_width1    2 
#property indicator_width2    2
#property indicator_width3    1 


extern int COUNT_BARS           = 1500;
extern int FAVORABLE_INDICATORS = 3;
extern bool M3_CORAL_FILTER     = false;
extern int DESFAVORABLE_INDIS   = 2;
  
//---- buffers
double Up[];
double Down[];
double Cerrar[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   
   SetIndexStyle(0, DRAW_ARROW,EMPTY,2,Lime);
   SetIndexStyle(1, DRAW_ARROW,EMPTY,2,Red);
   SetIndexStyle(2, DRAW_ARROW,EMPTY,1,Yellow);
   SetIndexBuffer(0, Up);
   SetIndexBuffer(1, Down);
   SetIndexBuffer(2, Cerrar);
 
   SetIndexArrow(0, 233);
   SetIndexArrow(1, 234);
   SetIndexArrow(2, 159);

   SetIndexLabel(0,"Cruce alcista");
   SetIndexLabel(1,"Cruce bajista");
   SetIndexLabel(2,"Fin de tendencia");
   
   string short_name="Cruce de medias mviles";
   
   IndicatorShortName(short_name);
   
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int contador, limit, counted_bars=IndicatorCounted();

   if (counted_bars < 0) return(-1);
   
   for(int i=0;i<COUNT_BARS;i++) 
   {
      Up[i]=EMPTY_VALUE;
      Down[i]=EMPTY_VALUE;
      Cerrar[i]=EMPTY_VALUE;
   }
   
   if(counted_bars>0) limit=Bars-counted_bars;
   limit--;
   
   double FAST_OLD,FAST_NEW,SLOW_OLD,SLOW_NEW;
   
   string MACD,FIM,STOCH,CCI,PALLADA;
   
   string ULTIMO="";
      
   for( contador=COUNT_BARS; contador>=0; contador--)
   {
      int ALCISTAS=0,BAJISTAS=0,RANGES=0;
   
      // MACD
      if(iCustom(NULL,0,"NASAP_13 OsMA i MACD",true,false,0,contador)==1) MACD="RANGE";
      if(iCustom(NULL,0,"NASAP_13 OsMA i MACD",true,false,1,contador)==1) MACD="ALCISTA";
      if(iCustom(NULL,0,"NASAP_13 OsMA i MACD",true,false,2,contador)==1) MACD="BAJISTA";
      
      // FIM
      if(iCustom(NULL,0,"NASAP_13 FIM",true,false,0,contador)==1) FIM="RANGE";
      if(iCustom(NULL,0,"NASAP_13 FIM",true,false,1,contador)==1) FIM="ALCISTA";
      if(iCustom(NULL,0,"NASAP_13 FIM",true,false,2,contador)==1) FIM="BAJISTA";
      
      // STOCH
      if(iCustom(NULL,0,"NASAP_13 Stochastic",true,false,0,contador)==1) STOCH="RANGE";
      if(iCustom(NULL,0,"NASAP_13 Stochastic",true,false,1,contador)==1) STOCH="ALCISTA";
      if(iCustom(NULL,0,"NASAP_13 Stochastic",true,false,2,contador)==1) STOCH="BAJISTA";
      
      // CCI
      if(iCustom(NULL,0,"NASAP_13 CCI",true,false,0,contador)==1) CCI="RANGE";
      if(iCustom(NULL,0,"NASAP_13 CCI",true,false,1,contador)==1) CCI="ALCISTA";
      if(iCustom(NULL,0,"NASAP_13 CCI",true,false,2,contador)==1) CCI="BAJISTA";
      
      
      if(MACD=="ALCISTA") ALCISTAS+=1;
      if(FIM=="ALCISTA") ALCISTAS+=1;
      if(STOCH=="ALCISTA") ALCISTAS+=1;
      if(CCI=="ALCISTA") ALCISTAS+=1;
      
      if(MACD=="BAJISTA") BAJISTAS+=1;
      if(FIM=="BAJISTA") BAJISTAS+=1;
      if(STOCH=="BAJISTA") BAJISTAS+=1;
      if(CCI=="BAJISTA") BAJISTAS+=1;
      
      if(MACD=="RANGE") RANGES+=1;
      if(FIM=="RANGE") RANGES+=1;
      if(STOCH=="RANGE") RANGES+=1;
      if(CCI=="RANGE") RANGES+=1;
      
      if(ALCISTAS<DESFAVORABLE_INDIS && ULTIMO=="ALCISTA")
      {
         //Cerrar[contador]=iEnvelopes(NULL,0,1,MODE_SMA,0,PRICE_LOW,0.1,MODE_LOWER,contador);
         ULTIMO="NULO"; 
      }
      
      if(BAJISTAS<DESFAVORABLE_INDIS && ULTIMO=="BAJISTA")
      {
         //Cerrar[contador]=iEnvelopes(NULL,0,1,MODE_SMA,0,PRICE_HIGH,0.1,MODE_UPPER,contador); 
         ULTIMO="NULO"; 
      }
      
      if(ALCISTAS>=FAVORABLE_INDICATORS && ULTIMO!="ALCISTA") 
      { 
         Up[contador]=iEnvelopes(NULL,0,1,MODE_SMA,0,PRICE_LOW,0.1,MODE_LOWER,contador); 
         ULTIMO="ALCISTA"; 
      }
      
      if(BAJISTAS>=FAVORABLE_INDICATORS && ULTIMO!="BAJISTA") 
      { 
         Down[contador]=iEnvelopes(NULL,0,1,MODE_SMA,0,PRICE_HIGH,0.1,MODE_UPPER,contador); 
         ULTIMO="BAJISTA"; 
      }
      
   }
   
   return(0);
}
  